

//=================================
/* ゲーム本編に使う		*/
//==================================

#include "game.h"

// ウェイト構造体
struct WAIT{
	int		mondai	; // 問題の出るまでの待ち時間
	int		mati	; // 問題がいったん止まり、再び動きだすまでの時間
	short		hantei	; // 判定のゲージ
} ;

//　カウント構造体			
struct COUNT{
	short 		timer	; // ３、２、１、GO!のカウント 
	short 		mondai	; // 問題がでるまでの待ち時間カウント
	short 		mati	; // 問題がいったん止まって出るまでのカウント
	short 		hantei	; // 問題がでてゲージが０になるまでのカウント
	short 		ke_ka	; // 行動を起こして、正解か不正解かの待ちカウント
	int		gameover; // ゲームオーバーのカウント
	int		goe	; // ゲームオーバーの絵を出すカウント
					

} ;      

// タイトル画面
void Title(SDL_Surface 	*screen){

	SDL_Event 	event		; // イベント

	SDL_Surface 	*img_title	; // タイトル画面の画像
	SDL_Surface 	*img_tagu	; // スタートなどの選択のタグ
	SDL_Surface	*img_char	; // タイトル画面のキャラ画像
	SDL_Surface	*img_haikei	; // 背景

	Mix_Music	*ms_title=NULL 	; // タイトルの音楽

	unsigned char 	flg = 0		; // ゲームループフラグ
	unsigned char	sentaku_flg = 0 ; // どのタグを選択しているかのフラグ
	short		hx = 0		; // 背景のスクロール座標

	int		ctime		; // キャラの出るまでのタイム
	int		ctimecnt = 0	; // キャラの出るまでのカウント
	unsigned char	cflg = 0	; // キャラが出てるかのフラグ

	int		cx 		; // キャラの座標
	int		cm		; // キャラの向き
	short		ccnt	= 0	; // キャラのカウント
	unsigned char	eflg 		; // キャラの絵のフラグ
	

	short		color = 0	; // カラーチェンジフラグ
	short		mira = 0	; // ミラーモードフラグ	

	//int 		rgb		;
	//SDL_PixelFormat	*fmt		;


	// 画像の読み込み-------------------------
	// タイトル
	img_title = ( SDL_Surface *)IMG_Load("picture/title.bmp") ;
	if( img_title==NULL ) printf("NOT READ BMP1\n") ;

	// 選択タグ
	img_tagu = ( SDL_Surface *)IMG_Load("picture/Title_tagu.bmp");
	if( img_tagu==NULL ) printf("NOT READ BMP2\n") ;

	// キャラ
	img_char = ( SDL_Surface *)IMG_Load("picture/char_ugoki.bmp");
	if( img_char==NULL ) printf("NOT READ BMP2\n") ;

	// 背景
	img_haikei = ( SDL_Surface *)IMG_Load("picture/haikei1.bmp");
	if( img_haikei==NULL ) printf("NOT READ BMP3\n") ;



	// 透過処理
	SDL_SetColorKey( img_title, SDL_SRCCOLORKEY, 0x00f0f0f0 ) ;
	SDL_SetColorKey( img_tagu, SDL_SRCCOLORKEY, 0x00f0f0f0 	) ;
	SDL_SetColorKey( img_char, SDL_SRCCOLORKEY, 0x00f0f0f0	) ;


	ctime = 10+( random()%100 ) ; // 出るまでの時間
	
	// 音楽読み込み===========================================-

	ms_title = Mix_LoadMUS("sound/title.wav") ;
	Mix_PlayMusic( ms_title, -1 ) ; // 鳴らす


	// メインループ
	while( flg==0 ){


		while( SDL_PollEvent( &event ) ){

			switch( event.type ){
 
			case SDL_MOUSEBUTTONDOWN: // マウスのボタンを押したとき

				// もし矢印(左）を押したら
				if( Sentaku( event.motion.x, event.motion.y, 
						0, 0, 150, 390, 50, 50 )){

					if( sentaku_flg==0 ){ 	sentaku_flg=3 ; }
					else{			sentaku_flg-- ; }

				}
				
				// もし矢印(右）を押したら
				if( Sentaku( event.motion.x, event.motion.y,
						 0, 0, 440, 390, 50, 50 )){

					// 限界は５
					if( sentaku_flg==TAGUMAX-1 ){ 	sentaku_flg=0 ; }
					else{			    	sentaku_flg++ ; }
				}

				// タグを選択していたら
				if( Sentaku( event.motion.x, event.motion.y, 
						0, 0, 210, 380, 220, 70 ) ){

					switch( sentaku_flg ){

					case 0 : // START

						Mix_HaltMusic();
						MainGame( screen, color, mira )	;

						Mix_PlayMusic( ms_title, -1 ) ; // 鳴らす	
						ctime = 10+( random()%100 ) ; // 出るまでの時間
						ctimecnt = 0	;
						cflg = 0	;

					break ;

					case 1 : // SETUMEI
						Setumei( screen ) ;
						ctime = 10+( random()%100 ) ; // 出るまでの時間
						ctimecnt = 0	;
						cflg = 0	;
					break ;
				
					case 2 : // RANKING
						RankingShow( screen, mira )	;
						ctime = 10+( random()%100 ) ; // 出るまでの時間
						ctimecnt = 0	;
						cflg = 0	;
					break ;

					case 3 : // EXIT
						flg = 1 		;
					break ;

					}
				}

				// 左下の太陽マークをクリックしたか
				if( Sentaku( event.motion.x, event.motion.y,
						0, 0, 0, 430, 50, 50 ) ){

					color = 1-color	; // ２パターンなのでこれで切り替れる
				}
				// 右下の鏡をクリックしたか
				if( Sentaku( event.motion.x, event.motion.y,
						0, 0, 580, 430, 50, 50 ) ){

					mira = 1-mira	; // ２パターンなのでこれで切り替れる
				}

				
				
			break ;

			case SDL_KEYDOWN:

				switch( event.key.keysym.sym ){

					case ESC_KEY :
						flg = 1 ;
					break 		;
				}
			break ;

			case SDL_QUIT:
			flg=1 ;
			break ;
			}	

		
		}

		// タイトル画面にいる間は描画する====================================

		// 画面クリア
		//fmt = screen->format 				;
		//rgb = SDL_MapRGB( fmt, 0x00, 0x00, 0x00 ) 	;
		//SDL_FillRect( screen, NULL, rgb ) 		;

		if( flg==0 ){

			// 背景の描画
			DrawHaikei( screen, img_haikei, 3, 2, hx )	;

			hx = ( hx+4 ) % 320	;


			// タイトル（普通） 描画
			DrawBMP( screen, 15, 20, img_title, 0, 0, 640, 355 ) ;

			// タグ
			if( Sentaku( event.motion.x, event.motion.y, 
						0, 0, 210, 380, 220, 70 ) ){
				DrawBMP( screen, 210, 380, img_tagu, 
						220, 0+( sentaku_flg*70 ), 220, 70 ) ;
			}
			else{
				DrawBMP( screen, 210, 380, img_tagu, 
						0, 0+( sentaku_flg*70 ), 220, 70 ) ;
			}

			// タグ選びの横矢印(左）
			if( Sentaku( event.motion.x, event.motion.y, 
							0, 0, 150, 390, 50, 50 )){
				DrawBMP( screen, 150, 390, img_tagu, 500, 0, 60, 50 ) ;
			}
			else{
				DrawBMP( screen, 150, 390, img_tagu, 440, 0, 60, 50 ) ;
			}

			// タグ選びの横矢印（右）
			if( Sentaku( event.motion.x, event.motion.y, 
							0, 0, 440, 390, 50, 50 )){
				DrawBMP( screen, 440, 390, img_tagu, 500, 50, 60, 50 ) ;
			}
			else{
				DrawBMP( screen, 440, 390, img_tagu, 440, 50, 60, 50 ) ;
			}

			// 左下に太陽（カラーチェンジ）
			DrawBMP( screen, 0, 430, img_tagu, 440+( color*50 ), 150, 50, 50 ) ;

			// 右下に鏡
			DrawBMP( screen, 580, 430, img_tagu, 440+( mira*50 ), 100, 50, 50 ) ;



			// キャラ表示=============
			//　でてなかったら
			if( cflg==0 ){
				
				if( ctime==ctimecnt ){
					cflg = 1 ; // 出る
					cm = random()%2 ;
					eflg = 0 ;

					// 左方向
					if( cm==0 ) cx = 640+125 ;
				
					// 右方向
					else	    cx = -125 ;
	
				}
				else	ctimecnt++ ;
			}

			// 出ている
			else{

				// 左方向にGO
				if( cm==0 ){
					cx-=5 ;

					
				}
				// 右方向にGO
				else{
					cx+=5 ;

				}

				// 絵のフラグの切り替え
				if( ccnt==15 ){
					ccnt = 0		;
					eflg = ( eflg+1 )%4	;
				}
				else	ccnt++ ;

				// 端まで言ったらフラグ切り替え
				if( cx<-125 || cx>640+125 ){
					cflg 	= 0 	;
					ctime 	= 10+( random()%100 ) ; // 出るまでの時間
					ctimecnt = 0 	;
				}
				
			
				// キャラ表示
				DrawBMP( screen, cx, 240, img_char, eflg*125, cm*130, 125, 130 ) ;
				
			}


			// バックバッファ
			SDL_Flip( screen ) ;
			loopWait( ) ;

		}
		
	}

	// ビットマップの解放
	SDL_FreeSurface( img_title 	)	;
	SDL_FreeSurface( img_tagu 	) 	;
	SDL_FreeSurface( img_char	)	;
	SDL_FreeSurface( img_haikei 	)	;

	Mix_HaltMusic() ;
	Mix_FreeMusic( ms_title 	) 	;
	
}


void MainGame( SDL_Surface *screen, short char_color, short mon_mira ){

	//====================================
	//	ゲーム本編に使う変数
	//====================================
	SDL_Event 	event		;
	SDL_Surface 	*img_char	; // イメージ（キャラ）
	SDL_Surface	*img_kao	; // キャラの喜びなどの顔
	SDL_Surface	*img_tagu	; // 問題の枠などのBMP
	SDL_Surface	*img_score	; // スコア
	SDL_Surface	*img_haikei	; // 背景
	SDL_Surface	*img_mondai	; // 問題
	SDL_Surface	*img_count	; // 3,2,1,GO!!のカウント

	Mix_Music	*ms_game=NULL 	; // ゲームの音楽

	unsigned char	flg 	 	; // ループフラグ
	unsigned char	modoflg  	; // モードフラグ
					  // （０=タイマーカウント中、１=問題でてる中、
					  //  ２=回答OK、３=判定中、4=ゲームオーバー, 5=ランキング )

	unsigned char 	timerflg 	; // タイマーカウントのフラグ
	struct WAIT	Wait		; // ウェイト関連の構造体
	struct COUNT	Count		; // カウント関係の構造体

	unsigned char	i,j		; // 繰り返し変数
	
	//=====================================
	//	問題関係の変数
	//=====================================

	int		pata_n	 	; // パターン
	int		mojiflg		; // 問題の出している文字のフラグ
	short		handan		; // 正解したか不正解したかの判断
	short		seikai		; // 正解した回数
	short		hu_seikai	; // 不正解の回数

	short 		mflg		; // 文字をいったん止めているフラグ
					  // ０なら文字がでる、１なら止める、２なら再開
	int		mojiryou	; // 文字の出てる量
	int		speed		; // 文字の出るスピード

	unsigned char	mondai		; // 普通の問題か？特殊問題か？
	int 		go_hi		; // 正解か?不正解か?
	
	//======================================
	//	得点関係の変数
	//======================================

	long		tokuten			; // 得点
	long		tokuten2		; // 得点の表示のためのコピー
	long		waruatai		; // 得点の表示のための割る値
	long		purasu			; // 正解して得点にプラスする量
	int		tokuten_ban[ TOKU ]	; // 得点の表示


	//======================================
	//	キャラ関係の変数
	//======================================

	unsigned char	Whiteflg 	; // 白旗のフラグ
	unsigned char	Redflg 	 	; // 赤旗のフラグ
	unsigned char	ugoki 	 	; // キャラの動き
	unsigned char 	ugoki_wait  	; // キャラの動きのウェイト
	
	//int 		rgb		;
	//SDL_PixelFormat	*fmt		;

	//=====================================
	//	初期化
	//=====================================

	// 画像の読み込み-------------------------
	// キャラ

	// 色(普通）
	if( char_color==0 ){
		img_char = ( SDL_Surface *)IMG_Load("picture/char.bmp") 	;
		if( img_char==NULL ) printf("NOT READ BMP5\n") 			;

		img_kao = ( SDL_Surface *)IMG_Load("picture/kao.bmp") 		;
		if( img_kao==NULL ) printf("NOT READ BMP5\n") 			;
	}
	// 色（２P)
	else{
		img_char = ( SDL_Surface *)IMG_Load("picture/char_ex.bmp") 	;
		if( img_char==NULL ) printf("NOT READ BMP5\n") 			;

		img_kao = ( SDL_Surface *)IMG_Load("picture/kao_ex.bmp") 	;
		if( img_kao==NULL ) printf("NOT READ BMP5\n") 			;
	}
	

	// タグ
	img_tagu = ( SDL_Surface *)IMG_Load("picture/game_sub.bmp") 	;
	if( img_tagu==NULL ) printf("NOT READ BMP6\n") 			;

	// スコア
	img_score = ( SDL_Surface *)IMG_Load("picture/score.bmp") 	;
	if( img_score==NULL ) printf("NOT READ BMP7\n") 			;

	// 背景
	img_haikei = ( SDL_Surface *)IMG_Load("picture/haikei2.bmp") 	;
	if( img_haikei==NULL ) printf("NOT READ BMP8\n") 		;

	// 問題
	img_mondai = ( SDL_Surface *)IMG_Load("picture/mondai1.bmp") 	;
	if( img_mondai==NULL ) printf("NOT READ BMP9\n") 		;

	// カウント
	img_count = ( SDL_Surface *)IMG_Load("picture/count.bmp") 	;
	if( img_count==NULL ) printf("NOT READ BMP10\n") 			;



	// 透過処理
	SDL_SetColorKey( img_char, SDL_SRCCOLORKEY, 0x00fff000 ) 	;
	SDL_SetColorKey( img_kao, SDL_SRCCOLORKEY, 0x00fff000 ) 	;
	SDL_SetColorKey( img_tagu, SDL_SRCCOLORKEY, 0x00e4ff00 ) 	;
	SDL_SetColorKey( img_score, SDL_SRCCOLORKEY, 0x00e4ff00 ) 	;
	SDL_SetColorKey( img_count, SDL_SRCCOLORKEY, 0x00f0f0f0 ) 	;

	// 音楽読み込み===========================================-

	ms_game = Mix_LoadMUS("sound/game.wav") ;


	Wait.mondai	= 10 +( random()%40 ) 	; // 最低でも１０ぐらい感覚を開ける
	Wait.mati	= 10 +( random()%60 )	; 
	Wait.hantei	= 100			;

	Count.timer	= 0			;
	Count.mondai	= 0			;
	Count.mati	= 0			;
	Count.hantei	= 0			;
	Count.ke_ka	= 0			;
	Count.gameover  = 0			;
	Count.goe	= 0			;


	flg		= 0		;
	modoflg		= 0		;	
	timerflg	= 0		;

	pata_n 		= random()%3 	; // 問題のパターン決め
	mojiflg		= random()%12	; // 出す問題は12個
	handan		= 0		; 
	seikai		= 0		;
	hu_seikai	= 0		;
	mflg		= 0		;
	mojiryou	= 0		;
	speed		= 5+( random()%10 ) ;

	if( (random()%7)==0 ) mondai = 1 ; // 特殊問題
	else		      mondai = 0 ; // 普通問題


	tokuten		= 0		;

	for( i=0 ; i<TOKU ; i++ ) tokuten_ban[i] = 0 ;

	Whiteflg	= 0		;
	Redflg		= 0		;
	ugoki		= 0		;
	ugoki_wait	= 0		;



	// メインループ
	while( flg==0 ){

		while( SDL_PollEvent( &event ) ){

			switch( event.type ){
					
				case SDL_MOUSEBUTTONDOWN: // マウスのボタンを押したとき
				// 回答OKのときだけクリックできる			
				if( modoflg==2 ){

					// もし左上を押したら（白旗あげ）
					if( Sentaku( event.motion.x, event.motion.y,
						0, 0, 50, 90, 100, 100 ) ){
						Whiteflg = 1 ;
					}
				
					// もし右上を押したら（赤旗あげ）
					if( Sentaku( event.motion.x, event.motion.y, 
						0, 0, 490, 90, 100, 100) ){
						Redflg = 1 ;
					}

					// もし左下を押したら（白旗さげ）
					if( Sentaku( event.motion.x, event.motion.y,
						0, 0, 50, 250, 100, 100) ){
						Whiteflg = 2 ;
					}
				
					//　もし右下を押したら（赤旗さげ）
					if( Sentaku( event.motion.x, event.motion.y, 
						0, 0, 490, 250, 100, 100) ){
						Redflg = 2 ;
					}
				}
				
				break ;


				case SDL_KEYDOWN:
	
					switch( event.key.keysym.sym ){

					// エスケープで終了
					case ESC_KEY:
					flg=1	;
					break	;
					}

				break ;

				case SDL_QUIT	:
					flg=1 	;
				break ;

			}
		}
		
		// 通常状態、もしくは回答できる中
		if( modoflg==1 || modoflg==2 ){
			ugoki_wait++ ;
			if( ugoki_wait==18 ){ 
				ugoki_wait 	= 0 		; 
				ugoki 		= (ugoki+1) % 2 ; 

			}
		}

		

	// タイトル画面にいる間は描画する====================================

		// 画面クリア
		/*fmt = screen->format				;
		rgb = SDL_MapRGB( fmt, 0x00, 0x00, 0x00 )	;
		SDL_FillRect( screen, NULL, rgb )		;
		*/
	
	if( flg==0 ){

		// 背景の描画
		DrawHaikei( screen, img_haikei, 2, 2, 0 ) 		;	

		// キャラ表示
		DrawChar( screen, img_char, Whiteflg, Redflg, ugoki )	;

		// 回答OKなら上下ボタンを出す
		if( modoflg==2 ){
		
			// 矢印表示
			Drawyazirusi( screen, img_tagu, event.motion.x, event.motion.y ) ;

		}

		//score 
		DrawBMP( screen, 405, 0, img_score, 0, 0, 105, 35 ) 	; 

		// 得点
		for( i=0 ; i<5 ; i++ ){
			DrawBMP( screen, 515+( i*25 ), 0, img_score, 
				 tokuten_ban[i]*25, 35, 25, 35 ) 	;
		}

		// 判定ゲージ表示
		DrawGaji( screen, img_tagu, Wait.hantei*2, Count.hantei*2 ) 	;
	
		// 問題が出る枠
		DrawBMP( screen, 0, 360, img_tagu, 0, 200, 640, 120 ) 		;

		// 問題( mojiryouでちょっとずつ出す )
		DrawBMP( screen, 8, 380, img_mondai, mondai*505, mojiflg*85, mojiryou, 85 ) 	;

		// 不正解の回数
		DrawBMP( screen, 550, 368, img_tagu, 600, 105, 60, 48*hu_seikai )  	;

		
		// モードによって
		switch( modoflg ){

			// タイマーカウント中
			case 0 :

				// ３、２、１、GOとカウントしていく

				// GO!!の表示
				if( timerflg==3 ){
					DrawBMP( screen, 95, 100,
						img_count,  750, 0, 450, 250 ) ;
					Mix_PlayMusic( ms_game, -1 ) ; // 鳴らす
				}
				else{	DrawBMP( screen, 195, 100, 
						img_count, timerflg*250, 0, 250, 250 ) ;
				}

				Count.timer++ ;

				// Count.timerが35なら初期化してフラグも動かす
				if( Count.timer==35 ){
					Count.timer 	 = 0	;
					timerflg 	+= 1	;
				}

				// もしtimerflg が４になったらフラグを変える
				if( timerflg==4 ) modoflg = 1	; // ゲームスタート
			
			break ;

			// 通常状態
			case 1 :

				// カウントが同じになったら文字を出す
				if( Wait.mondai==Count.mondai ){

					// 文字止めていないとき
					if( mflg==0 || mflg==2 ){
						// スピード分出す
						mojiryou += speed 	; 

						// カウントの制限
						if( mojiryou>505 ){
							mojiryou = 505	;

						// 文字が全部でたらカウントを止めて、回答OKモードに切り替える
							modoflg  = 2	;
						}
					}
					// 文字を止めているとき
					else{
					 	Count.mati++ ;
					}
					

					// パターンによって文字の動きを変える
					switch( pata_n ){

					// 全部をいっきに出すのでそのまま
					case 0 : 
					break ;

					// 一旦止めるパターン１
					case 1 :
						
						if( mojiryou>105 && mflg==0 ){
							mojiryou= 105 	;
							mflg 	= 1 	;
						}
						// 再び動く
						if( mflg==1 && Wait.mati==Count.mati ){
							speed	= 5+( random()%10 ) 	; 
							mflg	= 2	;
						}	
					break ;

					// 一旦止めるパターン２
					case 2 :

						if( mojiryou>320 && mflg==0 ){
							mojiryou= 320	;
							mflg	= 1	;
						}
						// 再び動く
						if( mflg==1 && Wait.mati==Count.mati ){
							speed	= 5+( random()%10 ) 	; 
							mflg	= 2	;
						}
					break ;

					}	
				}
				else Count.mondai++ 		; 	
				
			break ;

			// 問題回答中
			case 2 :

				// 行動を起こしたら
				if( Whiteflg!=0 || Redflg!=0 ){

					// 普通問題
					if( mon_mira==0 ){

						go_hi = hantei( mojiflg, Whiteflg, Redflg) ;
					}
					// ミラー
					else	go_hi = hantei_ex( mojiflg, Whiteflg, Redflg) ;

					// 判定して１がえが帰ってきたら正解
					if( go_hi==1 ){
								
						handan	= 0	; // 正解

						// かかった時間によってプラスする得点の量を変える
						if( Count.hantei<20 ){
						
							// 特殊問題かそうでないか
							purasu = 100+( mondai*100 ) ;
							
						}
						else if( Count.hantei>=21 && Count.hantei<50 ){
			
							purasu = 80+( mondai*80 ) ;
							
						}
						else{
							purasu = 50+( mondai*50 ) ;
						}	
								
					}
					// ０が帰ってきたら不正解
					else{
						handan	= 1	; // 不正解

						// 特殊問題ならマイナス
						if( mondai==1 ){
							if( Count.hantei<20 ){	
								purasu = 200	;
							}
							else if( Count.hantei>=21 && Count.hantei<50 ){
								purasu = 160	;
							}
							else	purasu = 100	;
						}
					}
					modoflg = 3	;
					ugoki	= 0	;
					break ;
				}

				// カウントが終わル（ゲージが０）になったら不正解
				if( Count.hantei==Wait.hantei ){	

					ugoki	= 0	; // 動きを止める
					modoflg	= 3	;	
					handan	= 1	; // 不正解
				}
				else Count.hantei++	;

			break ;
			
			// 正解か不正解かの判定
			case 3 :
				// ウェイト
				if( Count.ke_ka==41 ){

					// 正解したとき得点プラス
					if( handan==0 ){

						seikai++			;

						// 5回ずつ正解したら判定ゲージを縮める
						// かつ得点が０で、ゲージが50超え
						if( (seikai%5)==0 && tokuten!=0 
							&& Wait.hantei>50 ){
							Wait.hantei -= 5 ;
						}

						// 得点にプラス
						tokuten	+= purasu		;

						// スコア表示のため
						tokuten2= tokuten		;
						waruatai = 10000		;

						for( i=0 ; i<TOKU-1 ; i++ ){
						tokuten_ban[i] = tokuten2/waruatai ;

						tokuten2 %= waruatai		;
						waruatai /= 10			;
						}

						tokuten_ban[ TOKU-1 ] = (int)tokuten2	;
					}

					// 不正解かつ、特殊問題ならマイナスする
					if( handan==1 && mondai==1 ){

						hu_seikai++	;
						// 得点にマイナス
						tokuten	-= purasu		;
						
						// 得点が0以下にならないように
						if( tokuten<0 ) tokuten = 0 	;

						// スコア表示のため
						tokuten2= tokuten		;
						waruatai = 10000		;

						for( i=0 ; i<TOKU-1 ; i++ ){
						tokuten_ban[i] = tokuten2/waruatai ;

						tokuten2 %= waruatai		;
						waruatai /= 10			;
						}

						tokuten_ban[ TOKU-1 ] = (int)tokuten2	;

						// 3回不正解したらゲームオーバー
						if( hu_seikai==3 ){
							
							// ビットマップの表示のため、２に戻す
							hu_seikai = 2 ;
							modoflg	  = 4 ; // GAMEOVER
				
							Mix_HaltMusic() ;
							break ;		// 余計な初期化をしないため
						}
					}
					
					// 普通の問題に不正解したら
					if( handan==1 && mondai==0 ){
						hu_seikai++	;
						// 3回不正解したらゲームオーバー
						if( hu_seikai==3 ){
							
							// ビットマップの表示のため、２に戻す
							hu_seikai = 2 ;
							modoflg	  = 4 ; // GAMEOVER

							Mix_HaltMusic() ;
							break ;		// 余計な初期化をしないため
						}
					}

					// 旗関係は先に初期化
					Whiteflg	= 0			;
					Redflg		= 0			;

					// 初期化
					Wait.mondai 	= 10 +( random()%40 ) 	;
					Wait.mati	= 10 +( random()%60 )	;

					Count.mondai	= 0			;
					Count.mati	= 0			;
					Count.hantei	= 0			;
					Count.ke_ka	= 0			;

					
	
					// 元の問題でてる中に戻す
					modoflg		= 1			;

					pata_n 		= random()%3		;
					mojiflg 	= random()%12		;
					handan		= 0			;
					mflg		= 0			;
					mojiryou	= 0			;	
					speed		= 5+( random()%10 ) 	; 

					if( (random()%7)==0 ) mondai = 1 ; // 特殊問題
					else		      mondai = 0 ; // 普通問題


					ugoki_wait 	= 0			;	
				}

				else{
					Count.ke_ka++ ; // ウェイトカウント
			
					// 喜び顔や、驚き顔
					DrawBMP( screen, 150, 50, img_kao, 
							0, handan*120, 340, 120 ) ;
					
						// ○や×をチカチカさせて出す		
						if( ( (Count.ke_ka/8)%2 )==0 ){

						// ◯か×
						DrawBMP( screen, 150, 10, img_tagu,
							 handan*340, 320, 340, 330 ) 	;

							// 正解したとき
							if( handan==0 ){
							// プラスする得点をチカチカさせて表示させる
							if( Count.hantei<20 ){
								DrawBMP( screen, 525, 45, img_score, 
									0, 70+( mondai*105 ), 100, 35 ) ; 
							}
							else if( Count.hantei>=21 && Count.hantei<50 ){
								DrawBMP( screen, 525, 45, img_score,
									 0, 105+( mondai*105 ), 100, 35 ) ; 
							}
							else 	DrawBMP( screen, 525, 45, img_score, 0, 140+( mondai*105 ), 100, 35 ) ; 
							}

							// 不正解かつ特殊問題ならマイナス
							if( handan==1 && mondai==1 ){

							if( Count.hantei<20 ){
								DrawBMP( screen, 525, 45, img_score, 
									100, 175, 100, 35 ) ; 
							}
							else if( Count.hantei>=21 && Count.hantei<50 ){
								DrawBMP( screen, 525, 45, img_score,
									 100, 210, 100, 35 ) ; 
							}
							else 	DrawBMP( screen, 525, 45, img_score, 100, 245, 100, 35 ) ; 
							}
					
						}
					
				}

				break ;

				// GAMEOVER
				case 4 :

					// 残念顔
					DrawBMP( screen, 150, 50, img_kao, 0, 240, 340, 120 ) ;

					// 絵を出す
					if( Count.goe<320 ){
						Count.goe	+=5 	;
					}
					//　文字を全部だしたらカウント
					else{
						if( Count.gameover==80 ){
							modoflg = 5 	; // ランキングにGO
						}
						else Count.gameover++ 	;
					}

					// Gameの部分
					DrawBMP( screen, 320-Count.goe, 200, img_tagu, 
						330-Count.goe, 660,  320-( 320-Count.goe ), 130 ) ;

					// OVERの部分
					DrawBMP( screen, 320, 200, img_tagu,
						330, 660, Count.goe, 130 ) ;
				break ;


				// ランキング場面
				case 5 :
					// 帰ってきた値が１ならゲーム再スタート
					if( ( Ranking( screen, tokuten )) ){

						Wait.mondai	= 10 +( random()%40 ) 	; // 最低でも１０ぐらい感覚を開ける
						Wait.mati	= 10 +( random()%60 )	; 
						Wait.hantei	= 100			;

						Count.timer	= 0			;
						Count.mondai	= 0			;
						Count.mati	= 0			;
						Count.hantei	= 0			;
						Count.ke_ka	= 0			;
						Count.gameover  = 0			;
						Count.goe	= 0			;

						modoflg		= 0		;	
						timerflg	= 0		;

						pata_n 		= random()%3 	; // 問題のパターン決め
						mojiflg		= random()%12	; // 出す問題は12個
						handan		= 0		; 
						seikai		= 0		;
						hu_seikai	= 0		;
						mflg		= 0		;
						mojiryou	= 0		;
						speed		= 5+( random()%10 ) ;

						if( (random()%7)==0 ) mondai = 1 ; // 特殊問題
						else		      mondai = 0 ; // 普通問題

						tokuten		= 0		;

						for( i=0 ; i<TOKU ; i++ ) tokuten_ban[i] = 0 ;

						Whiteflg	= 0		;
						Redflg		= 0		;
						ugoki		= 0		;
						ugoki_wait	= 0		;	
					}
					else flg = 1 ;
				
				break ;


			}

			// バックバッファ
			SDL_Flip( screen ) 	;
			loopWait()		;
		}

		
	}

	// ビットマップの解放
	SDL_FreeSurface( img_char 	)	;
	SDL_FreeSurface( img_kao	)	;
	SDL_FreeSurface( img_tagu 	) 	;
	SDL_FreeSurface( img_score	) 	;
	SDL_FreeSurface( img_haikei 	) 	;
	SDL_FreeSurface( img_mondai	)	;
	SDL_FreeSurface( img_count	)	;

	Mix_HaltMusic() ;
	Mix_FreeMusic( ms_game 	) 	;
	
}

// 矢印の表示
void Drawyazirusi( SDL_Surface *screen, SDL_Surface *img_tagu, int x, int y ){

	// 左上
	if( Sentaku( x, y, 0, 0, 50, 90, 100, 100 ) ){
		DrawBMP( screen, 50, 90, img_tagu, 100, 0, 100, 100 ) ;
	}
	else	DrawBMP( screen, 50, 90, img_tagu, 0, 0, 100, 100 ) ;

	// 右上
	if( Sentaku( x, y,  0, 0, 490, 90, 100, 100) ){
		DrawBMP( screen, 490, 90, img_tagu, 300, 0, 100, 100 ) ;
	}
	else	DrawBMP( screen, 490, 90, img_tagu, 200, 0, 100, 100 ) ;



	// 左下
	if( Sentaku( x, y, 0, 0, 50, 250, 100, 100) ){
		DrawBMP( screen, 50, 250, img_tagu, 100, 100, 100, 100 ) ;
	}
	else	DrawBMP( screen, 50, 250, img_tagu, 0, 100, 100, 100  ) ;
				
	//　もし右下を押したら（赤旗さげ）
	if( Sentaku( x, y, 0, 0, 490, 250, 100, 100) ){
		DrawBMP( screen, 490, 250, img_tagu, 300, 100, 100, 100 ) ;
	}
	else	DrawBMP( screen, 490, 250, img_tagu, 200, 100, 100, 100 ) ;
}



// 判定ゲージの表示
void DrawGaji( SDL_Surface *screen, SDL_Surface *img_tagu, short hantei, short count ){
	
	// 判定ゲージ赤
	DrawBMP( screen, 0, 0, img_tagu, 400, 140, hantei ,35 )		;
		
	// 判定ゲージ青
	DrawBMP( screen, 0, 0, img_tagu, 400, 105, hantei-count, 35 )	;

	// 判定ゲージ
	DrawBMP( screen, 0, 0, img_tagu, 400, 70, hantei, 35 )		;
	
	// 判定ゲージフタ
	DrawBMP( screen, hantei-14, 0, img_tagu, 600, 70, 40, 35 ) 	;
}

// キャラの表示
void DrawChar( SDL_Surface *screen, SDL_Surface *img_char, 
				unsigned char Whiteflg, unsigned char Redflg, unsigned char ugoki ){
	// キャラ表示
	if( Whiteflg==0 && Redflg==0 ){
		DrawBMP( screen, 150, 50, img_char, 0+( ugoki*340 ), 0, 340, 340 ) 	;
	}
	// 白旗あげさげ
	else if( Whiteflg!=0 && Redflg==0 ){	
		DrawBMP( screen, 150, 50, img_char, 0, 0+( Whiteflg*340 ), 340, 340 ) 	;
	}
	// 赤旗あげさげ
	else if( Whiteflg==0 && Redflg!=0 ){
		DrawBMP( screen, 150, 50, img_char, 340, 0+( Redflg*340 ), 340, 340 ) 	;
	}	
	
}

// 問題があっているかの判定
int hantei( int mojiflg, unsigned char Whiteflg, unsigned char Redflg ){
	
	if(	mojiflg==0  && Whiteflg==0 && Redflg==1 || // 赤あげて
		mojiflg==1  && Whiteflg==1 && Redflg==0 || // 白あげて
		mojiflg==2  && Whiteflg==0 && Redflg==2 || // 赤あげない
		mojiflg==3  && Whiteflg==2 && Redflg==0 || // 白あげない
		mojiflg==4  && Whiteflg==0 && Redflg==2 || // 赤あげないで
		mojiflg==5  && Whiteflg==2 && Redflg==0 || // 白あげないで
		mojiflg==6  && Whiteflg==0 && Redflg==2 || // 赤さげて
		mojiflg==7  && Whiteflg==2 && Redflg==0 || // 白さげて
		mojiflg==8  && Whiteflg==0 && Redflg==1 || // 赤さげない
		mojiflg==9  && Whiteflg==1 && Redflg==0 || // 白さげない
		mojiflg==10 && Whiteflg==0 && Redflg==1 || // 赤さげないで
		mojiflg==11 && Whiteflg==1 && Redflg==0    // 白さげないで
	)
	{ 	return 1 ;	} // 正解している
	else{	return 0 ;	} // 不正解している	
	
}

// ミラーでの問題があっているかの判定
int hantei_ex( int mojiflg, unsigned char Whiteflg, unsigned char Redflg ){

	if(	mojiflg==0  && Whiteflg==2 && Redflg==0 || // 赤あげて→白さげて
		mojiflg==1  && Whiteflg==0 && Redflg==2 || // 白あげて→赤さげて
		mojiflg==2  && Whiteflg==1 && Redflg==0 || // 赤あげない→白さげない
		mojiflg==3  && Whiteflg==0 && Redflg==1 || // 白あげない→赤さげない
		mojiflg==4  && Whiteflg==1 && Redflg==0 || // 赤あげないで→白さげないで
		mojiflg==5  && Whiteflg==0 && Redflg==1 || // 白あげないで→赤さげないで
		mojiflg==6  && Whiteflg==1 && Redflg==0 || // 赤さげて→白あげて
		mojiflg==7  && Whiteflg==0 && Redflg==1 || // 白さげて→赤あげて
		mojiflg==8  && Whiteflg==2 && Redflg==0 || // 赤さげない→白あげない
		mojiflg==9  && Whiteflg==0 && Redflg==2 || // 白さげない→赤あげない
		mojiflg==10 && Whiteflg==2 && Redflg==0 || // 赤さげないで→白あげないで
		mojiflg==11 && Whiteflg==0 && Redflg==2    // 白さげないで→赤あげないで
	)
	{ 	return 1 ;	} // 正解している
	else{	return 0 ;	} // 不正解してい
}






