
#include "ranking.h"

// ランキングのメイン関数
int Ranking( SDL_Surface *screen, long tokuten, short mon_mira ){
	
	SDL_Event 	event				;
	SDL_Surface 	*img_rank			; // ランキングの画像

	long		rank[ RANKNUM ]			; // ランキングの総数
	int 		rank_ban[ RANKNUM ][ RANKNUM ]	; // スコア表示の板
	int 		retu = 0			; // リターンする数字

	short		new 				; // 新しく入ったランクひょう
	unsigned char	newflg = 0 			; // NEWの表示フラグ
	short		ncnt = 0			; // Newのカウント

	unsigned char	i,j				;
	unsigned char 	flg = 0				; // ランキングのフラグ


	// 初期化 ================================================

	img_rank = ( SDL_Surface *)IMG_Load("picture/rank.bmp") 	;
	if( img_rank==NULL ) printf("NOT READ BMP4\n") 			;

	// 透過処理
	SDL_SetColorKey( img_rank, SDL_SRCCOLORKEY, 0x00ffd0d0 ) 	;


	// ランキングのロード===============================
	// 通常
	if( mon_mira==0 )	Rankload( rank ) 	;

	// ミラーモード
	else			Rankload_ex( rank ) 	;


	
	// ランクイン処理(得点が0以外ならランクイン）
	if( tokuten!=0 ) new = Rankin( tokuten, rank ) ;
	else		new = -1 ;
	

	// ランキングにセーブ==============================
	// 通常
	if( mon_mira==0 )	RankSave( rank )	;
	
	// ミラー
	else			RankSave_ex( rank )	;

	
	// 得点板に挿入
	Rankban( rank, rank_ban ) ;

	

	// メインループ
	while( flg==0 ){

		while( SDL_PollEvent( &event ) ){

			switch( event.type ){

				case SDL_MOUSEBUTTONDOWN: // マウスのボタンを押したとき

					// もう一回
					if( Sentaku( event.motion.x, event.motion.y, 
							0, 0, 350, 435, 120, 40) ){

						flg	= 1 ;
						retu	= 1 ;
					}

					// おわり
					if( Sentaku( event.motion.x, event.motion.y, 
							0, 0, 500, 435, 90, 40 ) ){
						flg	= 1 ;
						retu	= 0 ;
					}
				break ;

				case SDL_KEYDOWN:
	
					switch( event.key.keysym.sym ){

					// エスケープで終了
					case ESC_KEY:
					flg=1	;
					break	;
					}

				break ;

				case SDL_QUIT	:
					flg=1 	;
				break ;
			}
		}

		if( flg==0 ){

			// 背景
			DrawBMP( screen, 0, 0, img_rank, 0, 0, 640, 480 ) ;

			// 得点板の表示
			for( i=0 ; i<RANKNUM ; i++ ){

				for( j=0 ; j<RANKNUM ; j++ ){
					DrawBMP( screen, 235+( j*45 ), 155+( i*55 ), 
						img_rank, 45*rank_ban[i][j], 481, 45, 50 ) ;
				}
			}

			// Newの表示
			if( new!=-1 ){
				DrawBMP( screen, 490, 155+( new*55 ), img_rank, newflg*135, 570,  135, 50 ) ;
				
				if( ncnt==20 ){
					ncnt=0 ; 
					newflg=( newflg+1 )%4 ;
				}
				else	ncnt++ ;
			}

			// リベンジ
			if( Sentaku( event.motion.x, event.motion.y, 0, 0, 350, 435, 120, 40) ){
				DrawBMP( screen, 350, 435, img_rank, 120, 530, 120, 40 ) ;
			}
			else	DrawBMP( screen, 350, 435, img_rank, 0, 530, 120, 40 ) ;

			// イグジェット
			if( Sentaku( event.motion.x, event.motion.y, 0, 0, 500, 435, 90, 40 ) ){
				DrawBMP( screen, 500, 435, img_rank, 390, 530, 150, 40 ) ;
			}
			else	DrawBMP( screen, 500, 435, img_rank, 240, 530, 150, 40 ) ;

			// ミラーかそうでないか
			DrawBMP( screen, 10, 430, img_rank, 580, 490+( mon_mira*50 ), 40, 50 ) ;
		
			// バックバッファ
			SDL_Flip( screen ) 	;
			loopWait()		;
		}
		
	}

	// 後始末
	SDL_FreeSurface( img_rank )	;

	return retu	;

	
}

// ランキングを表示するだけ
void RankingShow( SDL_Surface *screen, short mon_mira ){

	SDL_Event 	event				;
	SDL_Surface 	*img_rank			; // ランキングの画像

	long		rank[ RANKNUM ]			; // ランキングの総数
	int 		rank_ban[ RANKNUM ][ RANKNUM ]	; // スコア表示の板
	unsigned char 	flg = 0				; // ランキングのフラグ

	unsigned char	i,j				;

	// 初期化 ================================================

	img_rank = ( SDL_Surface *)IMG_Load("picture/rank.bmp") 	;
	if( img_rank==NULL ) printf("NOT READ BMP\n") 			;

	// 透過処理
	SDL_SetColorKey( img_rank, SDL_SRCCOLORKEY, 0x00ffd0d0 ) 	;

	// ランキングのロード===============================
	// 通常
	if( mon_mira==0 )	Rankload( rank ) 	;

	// ミラーモード
	else			Rankload_ex( rank ) 	;

	// 得点板に挿入
	Rankban( rank, rank_ban ) ;

	// メインループ
	while( flg==0 ){

		while( SDL_PollEvent( &event ) ){

			switch( event.type ){

				case SDL_MOUSEBUTTONDOWN: // マウスのボタンを押したとき
					// おわり
					if( Sentaku( event.motion.x, event.motion.y, 
							0, 0, 500, 435, 90, 40 ) ){
						flg	= 1 ;
					}
				break ;

				case SDL_KEYDOWN:
	
					switch( event.key.keysym.sym ){

					// エスケープで終了
					case ESC_KEY:
					flg=1	;
					break	;
					}

				break ;

				case SDL_QUIT	:
					flg=1 	;
				break ;
			}
		}

		if( flg==0 ){

			// 背景
			DrawBMP( screen, 0, 0, img_rank, 0, 0, 640, 480 ) ;

			// 得点板の表示
			for( i=0 ; i<RANKNUM ; i++ ){

				for( j=0 ; j<RANKNUM ; j++ ){
					DrawBMP( screen, 235+( j*45 ), 155+( i*55 ), 
						img_rank, 45*rank_ban[i][j], 481, 45, 50 ) ;
				}
			}

			// イグジェット
			if( Sentaku( event.motion.x, event.motion.y, 0, 0, 500, 435, 90, 40 ) ){
				DrawBMP( screen, 500, 435, img_rank, 390, 530, 150, 40 ) ;
			}
			else	DrawBMP( screen, 500, 435, img_rank, 240, 530, 150, 40 ) ;

			// ミラーかそうでないか
			DrawBMP( screen, 0, 430, img_rank, 580, 490+( mon_mira*50 ), 40, 50 ) ;
		
			// バックバッファ
			SDL_Flip( screen ) 	;
			loopWait()		;
		}
		
	}

	// 後始末
	SDL_FreeSurface( img_rank )	;

}

// ランキングのロード関数（通常）
void Rankload( long rank[] ){

	FILE 		*fp 	; // ファイル変数
	long		score 	; // 読み込んだ得点を入れる

	unsigned char 	i 	;

	// ファイルオープン＆エラー処理
	if(( fp = fopen("rank_data/rank.dat", "r" )) ==NULL ){
		printf("エラー\n" ) ;
		for( i=0 ; i<RANKNUM ; i++ ) rank[i] = 0 ;
	}

	// エラーじゃなかったら
	else{
		i=0	;
		while( fscanf(fp, "%ld", &score )!=EOF
					 && i<RANKNUM ){
			rank[i] = score ;
			i++ ;
		}
		// クローズ
		fclose( fp ) ; 
	}

}

// ランキングのロード関数（ミラー）
void Rankload_ex( long rank[] ){

	FILE 		*fp 	; // ファイル変数
	long		score 	; // 読み込んだ得点を入れる

	unsigned char 	i 	;

	// ファイルオープン＆エラー処理
	if(( fp = fopen("rank_data/rank_mira.dat", "r" )) ==NULL ){
		printf("エラー\n" ) ;
		for( i=0 ; i<RANKNUM ; i++ ) rank[i] = 0 ;
	}

	// エラーじゃなかったら
	else{
		i=0	;
		while( fscanf(fp, "%ld", &score )!=EOF
					 && i<RANKNUM ){
			rank[i] = score ;
			i++ ;
		}
		// クローズ
		fclose( fp ) ; 
	}

}


// ランクインの処理
short Rankin( long tokuten, long rank[] ){

	unsigned char 	i,j		;	
	short		retu = -1	; // 返す値

	for( i=0 ; i<RANKNUM ; i++ ){

		// 比較して得点が以上なら挿入
		if( tokuten>=rank[i] ){

			for( j=RANKNUM-1 ; j>i ; j-- ){
				rank[j] = rank[ j-1 ] ;
			}

			rank[i] = tokuten ;
			retu = i ;
			break ;
		}
	}

	return retu ;

}

// 得点板にいれる
void Rankban( long rank[], int rank_ban[][ RANKNUM ] ){

	long		tokuten2 ; // コピーする得点
	long 		waruatai ; // 割る値
	unsigned char 	i,j	 ;

	for( i=0 ; i<RANKNUM ; i++ ){
		
		tokuten2	= rank[i]	;
		waruatai	= 10000		;
		for( j=0 ; j<RANKNUM ; j++ ){

			rank_ban[i][j] = (int)( tokuten2/waruatai ) ;
			tokuten2 %= waruatai	;
			waruatai /= 10		;
		}

		rank_ban[i][j] = (int)tokuten2	;
	}

}

// ランキングのセーブ(通常）
void RankSave( long rank[] ){

	FILE 	*fp 	; // ファイル変数
	short	i	;

	if( (fp = fopen("rank_data/rank.dat","w")) == NULL){
		printf("スコアランキングファイル　オープンエラー\n");
		exit(0);
	}
	for( i=0; i<RANKNUM; i++ ){
		fprintf(fp, "%ld\n", rank[i] ) ;
	}
	fclose( fp ) ;

}

// ランキングのセーブ（ミラー）
void RankSave_ex( long rank[] ){

	FILE 	*fp 	; // ファイル変数
	short	i	;

	if( (fp = fopen("rank_data/rank_mira.dat","w")) == NULL){
		printf("スコアランキングファイル　オープンエラー\n");
		exit(0);
	}
	for( i=0; i<RANKNUM; i++ ){
		fprintf(fp, "%ld\n", rank[i] ) ;
	}
	fclose( fp ) ;

}





